---
image: node:boron

before_script:
  - apt-get update -y && apt-get install build-essential -y
  - npm install gulp gulp-cli -g && npm install

stages:
  - build
  - test

lint:
  script: gulp lint
  stage: build
  only:
    - master
  tags:
    - docker
    - linux
  allow_failure: false
  when: always

test:
  script: gulp test
  services:
    - cassandra:3.0
    - rabbitmq:3-management
  stage: test
  variables:
    ACCOUNT: demo.account
    INPUT_PIPE: demo.pipe.storage
    BROKER: amqp://guest:guest@rabbitmq:5672
    CONFIG: '{"host":"cassandra","port":"9042","user":"cassandra","password":"","keyspace":"reekoh","schema":{"fields":{"id":{"type":"uuid","default":{"$db_function":"uuid()"}},"data_id":{"type":"bigint"},"co2":{"type":"text"},"temp":"int","quality":"float","reading_time":"timestamp","metadata":{"type":"map","typeDef":"<varchar, text>"},"list":{"type":"list","typeDef":"<varchar>"},"set":{"type":"set","typeDef":"<varchar>"},"random_data":"varchar","is_normal":"boolean","created":{"type":"timestamp","default":{"$db_function":"toTimestamp(now())"}}},"key":[["id"],"created"],"clustering_order":{"created":"desc"},"table_name":"home_control"}}'
  only:
    - master
  tags:
    - docker
    - linux
  allow_failure: false
  when: always
